/* FocusPicker.c generated by valac 0.56.17, the Vala compiler
 * generated from FocusPicker.vala, do not modify */

/* The focuspoint picker*/
/* The API is a bit strange as it's based on https://github.com/jonom/jquery-focuspoint#1-calculate-your-images-focus-point*/
/* In summary, they are coordinates, where (1,1) is the top-right corner of the image*/
/* and (-1,-1) is the bottom-left one*/
/* This widget is responsible not only for picking the position on top of the image,*/
/* but also converting the position between the API coordinates and the width-height GTK ones*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <graphene-gobject.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TUBA_WIDGETS_TYPE_FOCUS_PICKER (tuba_widgets_focus_picker_get_type ())
#define TUBA_WIDGETS_FOCUS_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TUBA_WIDGETS_TYPE_FOCUS_PICKER, TubaWidgetsFocusPicker))
#define TUBA_WIDGETS_FOCUS_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TUBA_WIDGETS_TYPE_FOCUS_PICKER, TubaWidgetsFocusPickerClass))
#define TUBA_WIDGETS_IS_FOCUS_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TUBA_WIDGETS_TYPE_FOCUS_PICKER))
#define TUBA_WIDGETS_IS_FOCUS_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TUBA_WIDGETS_TYPE_FOCUS_PICKER))
#define TUBA_WIDGETS_FOCUS_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TUBA_WIDGETS_TYPE_FOCUS_PICKER, TubaWidgetsFocusPickerClass))

typedef struct _TubaWidgetsFocusPicker TubaWidgetsFocusPicker;
typedef struct _TubaWidgetsFocusPickerClass TubaWidgetsFocusPickerClass;
typedef struct _TubaWidgetsFocusPickerPrivate TubaWidgetsFocusPickerPrivate;
enum  {
	TUBA_WIDGETS_FOCUS_PICKER_0_PROPERTY,
	TUBA_WIDGETS_FOCUS_PICKER_POS_X_PROPERTY,
	TUBA_WIDGETS_FOCUS_PICKER_POS_Y_PROPERTY,
	TUBA_WIDGETS_FOCUS_PICKER_NUM_PROPERTIES
};
static GParamSpec* tuba_widgets_focus_picker_properties[TUBA_WIDGETS_FOCUS_PICKER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _TubaWidgetsFocusPicker {
	GtkWidget parent_instance;
	TubaWidgetsFocusPickerPrivate * priv;
};

struct _TubaWidgetsFocusPickerClass {
	GtkWidgetClass parent_class;
};

struct _TubaWidgetsFocusPickerPrivate {
	GtkPicture* pic;
	GtkFixed* fixed;
	GtkImage* picker;
	GtkAspectFrame* frame;
	GtkOverlay* overlay;
	gdouble _pos_x;
	gdouble _pos_y;
	gdouble picker_width_half;
	gdouble picker_height_half;
	gboolean dragging;
};

static gint TubaWidgetsFocusPicker_private_offset;
static gpointer tuba_widgets_focus_picker_parent_class = NULL;

VALA_EXTERN GType tuba_widgets_focus_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TubaWidgetsFocusPicker, g_object_unref)
static void tuba_widgets_focus_picker_on_fixed_click (TubaWidgetsFocusPicker* self,
                                               gint n_press,
                                               gdouble x,
                                               gdouble y);
static void tuba_widgets_focus_picker_on_motion_real (TubaWidgetsFocusPicker* self,
                                               gdouble x,
                                               gdouble y);
static void tuba_widgets_focus_picker_on_pointer_click (TubaWidgetsFocusPicker* self);
static void tuba_widgets_focus_picker_on_pointer_click_release (TubaWidgetsFocusPicker* self);
static void tuba_widgets_focus_picker_on_motion (TubaWidgetsFocusPicker* self,
                                          gdouble x,
                                          gdouble y);
VALA_EXTERN void tuba_widgets_focus_picker_set_pos_x (TubaWidgetsFocusPicker* self,
                                          gdouble value);
VALA_EXTERN void tuba_widgets_focus_picker_set_pos_y (TubaWidgetsFocusPicker* self,
                                          gdouble value);
VALA_EXTERN TubaWidgetsFocusPicker* tuba_widgets_focus_picker_new (GdkPaintable* paintable);
VALA_EXTERN TubaWidgetsFocusPicker* tuba_widgets_focus_picker_construct (GType object_type,
                                                             GdkPaintable* paintable);
static void tuba_widgets_focus_picker_real_size_allocate (GtkWidget* base,
                                                   gint width,
                                                   gint height,
                                                   gint baseline);
static void tuba_widgets_focus_picker_compute_picker_half (TubaWidgetsFocusPicker* self);
static void tuba_widgets_focus_picker_update_dot_pos (TubaWidgetsFocusPicker* self);
static void tuba_widgets_focus_picker_real_measure (GtkWidget* base,
                                             GtkOrientation orientation,
                                             gint for_size,
                                             gint* minimum,
                                             gint* natural,
                                             gint* minimum_baseline,
                                             gint* natural_baseline);
static void tuba_widgets_focus_picker_real_snapshot (GtkWidget* base,
                                              GtkSnapshot* snapshot);
VALA_EXTERN gdouble tuba_widgets_focus_picker_get_pos_x (TubaWidgetsFocusPicker* self);
VALA_EXTERN gdouble tuba_widgets_focus_picker_get_pos_y (TubaWidgetsFocusPicker* self);
static GObject * tuba_widgets_focus_picker_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static void _tuba_widgets_focus_picker_on_pointer_click_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                            gint n_press,
                                                                            gdouble x,
                                                                            gdouble y,
                                                                            gpointer self);
static void _tuba_widgets_focus_picker_on_pointer_click_release_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                                     gint n_press,
                                                                                     gdouble x,
                                                                                     gdouble y,
                                                                                     gpointer self);
static void _tuba_widgets_focus_picker_on_fixed_click_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                          gint n_press,
                                                                          gdouble x,
                                                                          gdouble y,
                                                                          gpointer self);
static void _tuba_widgets_focus_picker_on_motion_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                                              gdouble x,
                                                                              gdouble y,
                                                                              gpointer self);
static void tuba_widgets_focus_picker_finalize (GObject * obj);
static GType tuba_widgets_focus_picker_get_type_once (void);
static void _vala_tuba_widgets_focus_picker_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_tuba_widgets_focus_picker_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
tuba_widgets_focus_picker_get_instance_private (TubaWidgetsFocusPicker* self)
{
	return G_STRUCT_MEMBER_P (self, TubaWidgetsFocusPicker_private_offset);
}

static void
tuba_widgets_focus_picker_on_fixed_click (TubaWidgetsFocusPicker* self,
                                          gint n_press,
                                          gdouble x,
                                          gdouble y)
{
#line 74 "../src/Widgets/FocusPicker.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/Widgets/FocusPicker.vala"
	if (self->priv->dragging) {
#line 75 "../src/Widgets/FocusPicker.vala"
		return;
#line 179 "FocusPicker.c"
	}
#line 77 "../src/Widgets/FocusPicker.vala"
	tuba_widgets_focus_picker_on_motion_real (self, x, y);
#line 183 "FocusPicker.c"
}

static void
tuba_widgets_focus_picker_on_pointer_click (TubaWidgetsFocusPicker* self)
{
#line 83 "../src/Widgets/FocusPicker.vala"
	g_return_if_fail (self != NULL);
#line 84 "../src/Widgets/FocusPicker.vala"
	self->priv->dragging = TRUE;
#line 193 "FocusPicker.c"
}

static void
tuba_widgets_focus_picker_on_pointer_click_release (TubaWidgetsFocusPicker* self)
{
#line 89 "../src/Widgets/FocusPicker.vala"
	g_return_if_fail (self != NULL);
#line 90 "../src/Widgets/FocusPicker.vala"
	self->priv->dragging = FALSE;
#line 203 "FocusPicker.c"
}

static void
tuba_widgets_focus_picker_on_motion (TubaWidgetsFocusPicker* self,
                                     gdouble x,
                                     gdouble y)
{
#line 96 "../src/Widgets/FocusPicker.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/Widgets/FocusPicker.vala"
	if (!self->priv->dragging) {
#line 97 "../src/Widgets/FocusPicker.vala"
		return;
#line 217 "FocusPicker.c"
	}
#line 99 "../src/Widgets/FocusPicker.vala"
	tuba_widgets_focus_picker_on_motion_real (self, x, y);
#line 221 "FocusPicker.c"
}

static void
tuba_widgets_focus_picker_on_motion_real (TubaWidgetsFocusPicker* self,
                                          gdouble x,
                                          gdouble y)
{
	GtkPicture* _tmp0_;
	GtkPicture* _tmp1_;
	GtkPicture* _tmp2_;
	GtkPicture* _tmp3_;
#line 104 "../src/Widgets/FocusPicker.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/Widgets/FocusPicker.vala"
	_tmp0_ = self->priv->pic;
#line 105 "../src/Widgets/FocusPicker.vala"
	x = CLAMP (x, (gdouble) 0, (gdouble) gtk_widget_get_width ((GtkWidget*) _tmp0_));
#line 106 "../src/Widgets/FocusPicker.vala"
	_tmp1_ = self->priv->pic;
#line 106 "../src/Widgets/FocusPicker.vala"
	y = CLAMP (y, (gdouble) 0, (gdouble) gtk_widget_get_height ((GtkWidget*) _tmp1_));
#line 108 "../src/Widgets/FocusPicker.vala"
	_tmp2_ = self->priv->pic;
#line 108 "../src/Widgets/FocusPicker.vala"
	tuba_widgets_focus_picker_set_pos_x (self, ((2 * x) / gtk_widget_get_width ((GtkWidget*) _tmp2_)) - 1);
#line 109 "../src/Widgets/FocusPicker.vala"
	_tmp3_ = self->priv->pic;
#line 109 "../src/Widgets/FocusPicker.vala"
	tuba_widgets_focus_picker_set_pos_y (self, (((2 * y) / gtk_widget_get_height ((GtkWidget*) _tmp3_)) - 1) * -1);
#line 251 "FocusPicker.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 116 "../src/Widgets/FocusPicker.vala"
	return self ? g_object_ref (self) : NULL;
#line 259 "FocusPicker.c"
}

TubaWidgetsFocusPicker*
tuba_widgets_focus_picker_construct (GType object_type,
                                     GdkPaintable* paintable)
{
	TubaWidgetsFocusPicker * self = NULL;
	GtkPicture* _tmp0_;
	GtkOverlay* _tmp1_;
	GtkPicture* _tmp2_;
	GtkPicture* _tmp3_;
	GdkPaintable* _tmp4_;
	GdkPaintable* _tmp5_;
	GtkOverlay* _tmp6_;
	GtkWidget* _tmp7_;
	GtkAspectFrame* _tmp8_ = NULL;
	GtkAspectFrame* _tmp9_;
	GtkFixed* _tmp10_;
	GtkImage* _tmp11_;
	GtkPicture* _tmp12_;
	GtkPicture* _tmp13_;
#line 112 "../src/Widgets/FocusPicker.vala"
	g_return_val_if_fail (paintable != NULL, NULL);
#line 112 "../src/Widgets/FocusPicker.vala"
	self = (TubaWidgetsFocusPicker*) g_object_new (object_type, NULL);
#line 113 "../src/Widgets/FocusPicker.vala"
	_tmp0_ = (GtkPicture*) gtk_picture_new_for_paintable (paintable);
#line 113 "../src/Widgets/FocusPicker.vala"
	g_object_ref_sink (_tmp0_);
#line 113 "../src/Widgets/FocusPicker.vala"
	_g_object_unref0 (self->priv->pic);
#line 113 "../src/Widgets/FocusPicker.vala"
	self->priv->pic = _tmp0_;
#line 114 "../src/Widgets/FocusPicker.vala"
	_tmp1_ = self->priv->overlay;
#line 114 "../src/Widgets/FocusPicker.vala"
	_tmp2_ = self->priv->pic;
#line 114 "../src/Widgets/FocusPicker.vala"
	gtk_overlay_set_child (_tmp1_, (GtkWidget*) _tmp2_);
#line 116 "../src/Widgets/FocusPicker.vala"
	_tmp3_ = self->priv->pic;
#line 116 "../src/Widgets/FocusPicker.vala"
	_tmp4_ = gtk_picture_get_paintable (_tmp3_);
#line 116 "../src/Widgets/FocusPicker.vala"
	_tmp5_ = _tmp4_;
#line 116 "../src/Widgets/FocusPicker.vala"
	_tmp6_ = self->priv->overlay;
#line 116 "../src/Widgets/FocusPicker.vala"
	_tmp7_ = _g_object_ref0 ((GtkWidget*) _tmp6_);
#line 116 "../src/Widgets/FocusPicker.vala"
	_tmp8_ = (GtkAspectFrame*) gtk_aspect_frame_new (0.5f, 0.5f, (gfloat) gdk_paintable_get_intrinsic_aspect_ratio (_tmp5_), FALSE);
#line 116 "../src/Widgets/FocusPicker.vala"
	gtk_aspect_frame_set_child (_tmp8_, _tmp7_);
#line 116 "../src/Widgets/FocusPicker.vala"
	_g_object_unref0 (_tmp7_);
#line 116 "../src/Widgets/FocusPicker.vala"
	g_object_ref_sink (_tmp8_);
#line 116 "../src/Widgets/FocusPicker.vala"
	_g_object_unref0 (self->priv->frame);
#line 116 "../src/Widgets/FocusPicker.vala"
	self->priv->frame = _tmp8_;
#line 124 "../src/Widgets/FocusPicker.vala"
	_tmp9_ = self->priv->frame;
#line 124 "../src/Widgets/FocusPicker.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp9_, (GtkWidget*) self);
#line 127 "../src/Widgets/FocusPicker.vala"
	_tmp10_ = self->priv->fixed;
#line 127 "../src/Widgets/FocusPicker.vala"
	_tmp11_ = self->priv->picker;
#line 127 "../src/Widgets/FocusPicker.vala"
	_tmp12_ = self->priv->pic;
#line 127 "../src/Widgets/FocusPicker.vala"
	_tmp13_ = self->priv->pic;
#line 127 "../src/Widgets/FocusPicker.vala"
	gtk_fixed_put (_tmp10_, (GtkWidget*) _tmp11_, (gdouble) (gtk_widget_get_width ((GtkWidget*) _tmp12_) / 2), (gdouble) (gtk_widget_get_height ((GtkWidget*) _tmp13_) / 2));
#line 112 "../src/Widgets/FocusPicker.vala"
	return self;
#line 337 "FocusPicker.c"
}

TubaWidgetsFocusPicker*
tuba_widgets_focus_picker_new (GdkPaintable* paintable)
{
#line 112 "../src/Widgets/FocusPicker.vala"
	return tuba_widgets_focus_picker_construct (TUBA_WIDGETS_TYPE_FOCUS_PICKER, paintable);
#line 345 "FocusPicker.c"
}

static void
tuba_widgets_focus_picker_real_size_allocate (GtkWidget* base,
                                              gint width,
                                              gint height,
                                              gint baseline)
{
	TubaWidgetsFocusPicker * self;
	GtkAspectFrame* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 130 "../src/Widgets/FocusPicker.vala"
	self = (TubaWidgetsFocusPicker*) base;
#line 131 "../src/Widgets/FocusPicker.vala"
	_tmp0_ = self->priv->frame;
#line 131 "../src/Widgets/FocusPicker.vala"
	gtk_widget_allocate ((GtkWidget*) _tmp0_, width, height, baseline, NULL);
#line 134 "../src/Widgets/FocusPicker.vala"
	if (self->priv->picker_width_half == ((gdouble) 0)) {
#line 134 "../src/Widgets/FocusPicker.vala"
		_tmp1_ = TRUE;
#line 367 "FocusPicker.c"
	} else {
#line 134 "../src/Widgets/FocusPicker.vala"
		_tmp1_ = self->priv->picker_height_half == ((gdouble) 0);
#line 371 "FocusPicker.c"
	}
#line 134 "../src/Widgets/FocusPicker.vala"
	if (_tmp1_) {
#line 134 "../src/Widgets/FocusPicker.vala"
		tuba_widgets_focus_picker_compute_picker_half (self);
#line 377 "FocusPicker.c"
	}
#line 136 "../src/Widgets/FocusPicker.vala"
	tuba_widgets_focus_picker_update_dot_pos (self);
#line 381 "FocusPicker.c"
}

static void
tuba_widgets_focus_picker_real_measure (GtkWidget* base,
                                        GtkOrientation orientation,
                                        gint for_size,
                                        gint* minimum,
                                        gint* natural,
                                        gint* minimum_baseline,
                                        gint* natural_baseline)
{
	TubaWidgetsFocusPicker * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint _vala_minimum_baseline = 0;
	gint _vala_natural_baseline = 0;
	GtkAspectFrame* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
#line 139 "../src/Widgets/FocusPicker.vala"
	self = (TubaWidgetsFocusPicker*) base;
#line 147 "../src/Widgets/FocusPicker.vala"
	_tmp0_ = self->priv->frame;
#line 147 "../src/Widgets/FocusPicker.vala"
	gtk_widget_measure ((GtkWidget*) _tmp0_, orientation, for_size, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
#line 147 "../src/Widgets/FocusPicker.vala"
	_vala_minimum = _tmp1_;
#line 147 "../src/Widgets/FocusPicker.vala"
	_vala_natural = _tmp2_;
#line 147 "../src/Widgets/FocusPicker.vala"
	_vala_minimum_baseline = _tmp3_;
#line 147 "../src/Widgets/FocusPicker.vala"
	_vala_natural_baseline = _tmp4_;
#line 139 "../src/Widgets/FocusPicker.vala"
	if (minimum) {
#line 139 "../src/Widgets/FocusPicker.vala"
		*minimum = _vala_minimum;
#line 421 "FocusPicker.c"
	}
#line 139 "../src/Widgets/FocusPicker.vala"
	if (natural) {
#line 139 "../src/Widgets/FocusPicker.vala"
		*natural = _vala_natural;
#line 427 "FocusPicker.c"
	}
#line 139 "../src/Widgets/FocusPicker.vala"
	if (minimum_baseline) {
#line 139 "../src/Widgets/FocusPicker.vala"
		*minimum_baseline = _vala_minimum_baseline;
#line 433 "FocusPicker.c"
	}
#line 139 "../src/Widgets/FocusPicker.vala"
	if (natural_baseline) {
#line 139 "../src/Widgets/FocusPicker.vala"
		*natural_baseline = _vala_natural_baseline;
#line 439 "FocusPicker.c"
	}
}

static void
tuba_widgets_focus_picker_real_snapshot (GtkWidget* base,
                                         GtkSnapshot* snapshot)
{
	TubaWidgetsFocusPicker * self;
#line 157 "../src/Widgets/FocusPicker.vala"
	self = (TubaWidgetsFocusPicker*) base;
#line 157 "../src/Widgets/FocusPicker.vala"
	g_return_if_fail (snapshot != NULL);
#line 158 "../src/Widgets/FocusPicker.vala"
	GTK_WIDGET_CLASS (tuba_widgets_focus_picker_parent_class)->snapshot (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), snapshot);
#line 454 "FocusPicker.c"
}

static void
tuba_widgets_focus_picker_update_dot_pos (TubaWidgetsFocusPicker* self)
{
	gint new_x = 0;
	GtkPicture* _tmp0_;
	gint new_y = 0;
	GtkPicture* _tmp1_;
	GtkFixed* _tmp2_;
	GtkImage* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
#line 165 "../src/Widgets/FocusPicker.vala"
	g_return_if_fail (self != NULL);
#line 166 "../src/Widgets/FocusPicker.vala"
	_tmp0_ = self->priv->pic;
#line 166 "../src/Widgets/FocusPicker.vala"
	new_x = gtk_widget_get_width ((GtkWidget*) _tmp0_) / 2;
#line 167 "../src/Widgets/FocusPicker.vala"
	_tmp1_ = self->priv->pic;
#line 167 "../src/Widgets/FocusPicker.vala"
	new_y = gtk_widget_get_height ((GtkWidget*) _tmp1_) / 2;
#line 169 "../src/Widgets/FocusPicker.vala"
	_tmp2_ = self->priv->fixed;
#line 169 "../src/Widgets/FocusPicker.vala"
	_tmp3_ = self->priv->picker;
#line 169 "../src/Widgets/FocusPicker.vala"
	_tmp4_ = tuba_widgets_focus_picker_get_pos_x (self);
#line 169 "../src/Widgets/FocusPicker.vala"
	_tmp5_ = _tmp4_;
#line 169 "../src/Widgets/FocusPicker.vala"
	_tmp6_ = tuba_widgets_focus_picker_get_pos_y (self);
#line 169 "../src/Widgets/FocusPicker.vala"
	_tmp7_ = _tmp6_;
#line 169 "../src/Widgets/FocusPicker.vala"
	gtk_fixed_move (_tmp2_, (GtkWidget*) _tmp3_, (new_x + (new_x * _tmp5_)) - self->priv->picker_width_half, (new_y + ((new_y * _tmp7_) * -1)) - self->priv->picker_height_half);
#line 494 "FocusPicker.c"
}

static void
tuba_widgets_focus_picker_compute_picker_half (TubaWidgetsFocusPicker* self)
{
	graphene_rect_t rect = {0};
	GtkImage* _tmp0_;
	GtkFixed* _tmp1_;
	graphene_rect_t _tmp2_ = {0};
	gboolean _tmp3_;
#line 176 "../src/Widgets/FocusPicker.vala"
	g_return_if_fail (self != NULL);
#line 178 "../src/Widgets/FocusPicker.vala"
	_tmp0_ = self->priv->picker;
#line 178 "../src/Widgets/FocusPicker.vala"
	_tmp1_ = self->priv->fixed;
#line 178 "../src/Widgets/FocusPicker.vala"
	_tmp3_ = gtk_widget_compute_bounds ((GtkWidget*) _tmp0_, (GtkWidget*) _tmp1_, &_tmp2_);
#line 178 "../src/Widgets/FocusPicker.vala"
	rect = _tmp2_;
#line 178 "../src/Widgets/FocusPicker.vala"
	if (!_tmp3_) {
#line 517 "FocusPicker.c"
		GtkImage* _tmp4_;
		GtkImage* _tmp5_;
#line 179 "../src/Widgets/FocusPicker.vala"
		_tmp4_ = self->priv->picker;
#line 179 "../src/Widgets/FocusPicker.vala"
		self->priv->picker_width_half = (gdouble) (gtk_widget_get_width ((GtkWidget*) _tmp4_) / 2);
#line 180 "../src/Widgets/FocusPicker.vala"
		_tmp5_ = self->priv->picker;
#line 180 "../src/Widgets/FocusPicker.vala"
		self->priv->picker_height_half = (gdouble) (gtk_widget_get_height ((GtkWidget*) _tmp5_) / 2);
#line 528 "FocusPicker.c"
	} else {
		graphene_rect_t _tmp6_;
		graphene_size_t _tmp7_;
		graphene_rect_t _tmp8_;
		graphene_size_t _tmp9_;
#line 182 "../src/Widgets/FocusPicker.vala"
		_tmp6_ = rect;
#line 182 "../src/Widgets/FocusPicker.vala"
		_tmp7_ = _tmp6_.size;
#line 182 "../src/Widgets/FocusPicker.vala"
		self->priv->picker_width_half = (gdouble) (_tmp7_.width / 2);
#line 183 "../src/Widgets/FocusPicker.vala"
		_tmp8_ = rect;
#line 183 "../src/Widgets/FocusPicker.vala"
		_tmp9_ = _tmp8_.size;
#line 183 "../src/Widgets/FocusPicker.vala"
		self->priv->picker_height_half = (gdouble) (_tmp9_.height / 2);
#line 546 "FocusPicker.c"
	}
}

gdouble
tuba_widgets_focus_picker_get_pos_x (TubaWidgetsFocusPicker* self)
{
	gdouble result;
#line 16 "../src/Widgets/FocusPicker.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 16 "../src/Widgets/FocusPicker.vala"
	result = self->priv->_pos_x;
#line 16 "../src/Widgets/FocusPicker.vala"
	return result;
#line 560 "FocusPicker.c"
}

void
tuba_widgets_focus_picker_set_pos_x (TubaWidgetsFocusPicker* self,
                                     gdouble value)
{
#line 17 "../src/Widgets/FocusPicker.vala"
	g_return_if_fail (self != NULL);
#line 18 "../src/Widgets/FocusPicker.vala"
	self->priv->_pos_x = value;
#line 20 "../src/Widgets/FocusPicker.vala"
	tuba_widgets_focus_picker_update_dot_pos (self);
#line 17 "../src/Widgets/FocusPicker.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_focus_picker_properties[TUBA_WIDGETS_FOCUS_PICKER_POS_X_PROPERTY]);
#line 575 "FocusPicker.c"
}

gdouble
tuba_widgets_focus_picker_get_pos_y (TubaWidgetsFocusPicker* self)
{
	gdouble result;
#line 26 "../src/Widgets/FocusPicker.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 26 "../src/Widgets/FocusPicker.vala"
	result = self->priv->_pos_y;
#line 26 "../src/Widgets/FocusPicker.vala"
	return result;
#line 588 "FocusPicker.c"
}

void
tuba_widgets_focus_picker_set_pos_y (TubaWidgetsFocusPicker* self,
                                     gdouble value)
{
#line 27 "../src/Widgets/FocusPicker.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Widgets/FocusPicker.vala"
	self->priv->_pos_y = value;
#line 30 "../src/Widgets/FocusPicker.vala"
	tuba_widgets_focus_picker_update_dot_pos (self);
#line 27 "../src/Widgets/FocusPicker.vala"
	g_object_notify_by_pspec ((GObject *) self, tuba_widgets_focus_picker_properties[TUBA_WIDGETS_FOCUS_PICKER_POS_Y_PROPERTY]);
#line 603 "FocusPicker.c"
}

static void
_tuba_widgets_focus_picker_on_pointer_click_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                       gint n_press,
                                                                       gdouble x,
                                                                       gdouble y,
                                                                       gpointer self)
{
#line 58 "../src/Widgets/FocusPicker.vala"
	tuba_widgets_focus_picker_on_pointer_click ((TubaWidgetsFocusPicker*) self);
#line 615 "FocusPicker.c"
}

static void
_tuba_widgets_focus_picker_on_pointer_click_release_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                                gint n_press,
                                                                                gdouble x,
                                                                                gdouble y,
                                                                                gpointer self)
{
#line 59 "../src/Widgets/FocusPicker.vala"
	tuba_widgets_focus_picker_on_pointer_click_release ((TubaWidgetsFocusPicker*) self);
#line 627 "FocusPicker.c"
}

static void
_tuba_widgets_focus_picker_on_fixed_click_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                     gint n_press,
                                                                     gdouble x,
                                                                     gdouble y,
                                                                     gpointer self)
{
#line 66 "../src/Widgets/FocusPicker.vala"
	tuba_widgets_focus_picker_on_fixed_click ((TubaWidgetsFocusPicker*) self, n_press, x, y);
#line 639 "FocusPicker.c"
}

static void
_tuba_widgets_focus_picker_on_motion_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                                         gdouble x,
                                                                         gdouble y,
                                                                         gpointer self)
{
#line 70 "../src/Widgets/FocusPicker.vala"
	tuba_widgets_focus_picker_on_motion ((TubaWidgetsFocusPicker*) self, x, y);
#line 650 "FocusPicker.c"
}

static GObject *
tuba_widgets_focus_picker_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TubaWidgetsFocusPicker * self;
	GtkOverlay* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_;
	GtkImage* _tmp4_ = NULL;
	GtkFixed* _tmp5_;
	GtkOverlay* _tmp6_;
	GtkFixed* _tmp7_;
	GtkOverlay* _tmp8_;
	GtkFixed* _tmp9_;
	GtkGestureClick* picker_click_gesture = NULL;
	GtkGestureClick* _tmp10_ = NULL;
	GtkGestureClick* _tmp11_;
	GtkGestureClick* _tmp12_;
	GtkImage* _tmp13_;
	GtkGestureClick* _tmp14_;
	GtkEventController* _tmp15_;
	GtkGestureClick* fixed_click_gesture = NULL;
	GtkGestureClick* _tmp16_ = NULL;
	GtkGestureClick* _tmp17_;
	GtkFixed* _tmp18_;
	GtkGestureClick* _tmp19_;
	GtkEventController* _tmp20_;
	GtkEventControllerMotion* motion = NULL;
	GtkEventControllerMotion* _tmp21_;
	GtkEventControllerMotion* _tmp22_;
	GtkFixed* _tmp23_;
	GtkEventControllerMotion* _tmp24_;
	GtkEventController* _tmp25_;
#line 37 "../src/Widgets/FocusPicker.vala"
	parent_class = G_OBJECT_CLASS (tuba_widgets_focus_picker_parent_class);
#line 37 "../src/Widgets/FocusPicker.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 37 "../src/Widgets/FocusPicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUBA_WIDGETS_TYPE_FOCUS_PICKER, TubaWidgetsFocusPicker);
#line 38 "../src/Widgets/FocusPicker.vala"
	_tmp0_ = (GtkOverlay*) gtk_overlay_new ();
#line 38 "../src/Widgets/FocusPicker.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp0_, TRUE);
#line 38 "../src/Widgets/FocusPicker.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp0_, TRUE);
#line 38 "../src/Widgets/FocusPicker.vala"
	g_object_ref_sink (_tmp0_);
#line 38 "../src/Widgets/FocusPicker.vala"
	_g_object_unref0 (self->priv->overlay);
#line 38 "../src/Widgets/FocusPicker.vala"
	self->priv->overlay = _tmp0_;
#line 43 "../src/Widgets/FocusPicker.vala"
	_tmp1_ = g_strdup ("osd");
#line 43 "../src/Widgets/FocusPicker.vala"
	_tmp2_ = g_strdup ("focus-picker");
#line 43 "../src/Widgets/FocusPicker.vala"
	_tmp3_ = g_new0 (gchar*, 2 + 1);
#line 43 "../src/Widgets/FocusPicker.vala"
	_tmp3_[0] = _tmp1_;
#line 43 "../src/Widgets/FocusPicker.vala"
	_tmp3_[1] = _tmp2_;
#line 43 "../src/Widgets/FocusPicker.vala"
	_tmp4_ = (GtkImage*) gtk_image_new_from_icon_name ("tuba-radio-checked-symbolic");
#line 43 "../src/Widgets/FocusPicker.vala"
	gtk_widget_set_css_classes ((GtkWidget*) _tmp4_, _tmp3_);
#line 43 "../src/Widgets/FocusPicker.vala"
	_tmp3_ = (_vala_array_free (_tmp3_, 2, (GDestroyNotify) g_free), NULL);
#line 43 "../src/Widgets/FocusPicker.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp4_, GTK_ALIGN_CENTER);
#line 43 "../src/Widgets/FocusPicker.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp4_, GTK_ALIGN_CENTER);
#line 43 "../src/Widgets/FocusPicker.vala"
	gtk_image_set_icon_size (_tmp4_, GTK_ICON_SIZE_LARGE);
#line 43 "../src/Widgets/FocusPicker.vala"
	g_object_ref_sink (_tmp4_);
#line 43 "../src/Widgets/FocusPicker.vala"
	_g_object_unref0 (self->priv->picker);
#line 43 "../src/Widgets/FocusPicker.vala"
	self->priv->picker = _tmp4_;
#line 50 "../src/Widgets/FocusPicker.vala"
	_tmp5_ = (GtkFixed*) gtk_fixed_new ();
#line 50 "../src/Widgets/FocusPicker.vala"
	g_object_ref_sink (_tmp5_);
#line 50 "../src/Widgets/FocusPicker.vala"
	_g_object_unref0 (self->priv->fixed);
#line 50 "../src/Widgets/FocusPicker.vala"
	self->priv->fixed = _tmp5_;
#line 51 "../src/Widgets/FocusPicker.vala"
	_tmp6_ = self->priv->overlay;
#line 51 "../src/Widgets/FocusPicker.vala"
	_tmp7_ = self->priv->fixed;
#line 51 "../src/Widgets/FocusPicker.vala"
	gtk_overlay_add_overlay (_tmp6_, (GtkWidget*) _tmp7_);
#line 52 "../src/Widgets/FocusPicker.vala"
	_tmp8_ = self->priv->overlay;
#line 52 "../src/Widgets/FocusPicker.vala"
	_tmp9_ = self->priv->fixed;
#line 52 "../src/Widgets/FocusPicker.vala"
	gtk_overlay_set_clip_overlay (_tmp8_, (GtkWidget*) _tmp9_, TRUE);
#line 54 "../src/Widgets/FocusPicker.vala"
	_tmp10_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 54 "../src/Widgets/FocusPicker.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp10_, (guint) GDK_BUTTON_PRIMARY);
#line 54 "../src/Widgets/FocusPicker.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp10_, GTK_PHASE_CAPTURE);
#line 54 "../src/Widgets/FocusPicker.vala"
	picker_click_gesture = _tmp10_;
#line 58 "../src/Widgets/FocusPicker.vala"
	_tmp11_ = picker_click_gesture;
#line 58 "../src/Widgets/FocusPicker.vala"
	g_signal_connect_object (_tmp11_, "pressed", (GCallback) _tuba_widgets_focus_picker_on_pointer_click_gtk_gesture_click_pressed, self, 0);
#line 59 "../src/Widgets/FocusPicker.vala"
	_tmp12_ = picker_click_gesture;
#line 59 "../src/Widgets/FocusPicker.vala"
	g_signal_connect_object (_tmp12_, "released", (GCallback) _tuba_widgets_focus_picker_on_pointer_click_release_gtk_gesture_click_released, self, 0);
#line 60 "../src/Widgets/FocusPicker.vala"
	_tmp13_ = self->priv->picker;
#line 60 "../src/Widgets/FocusPicker.vala"
	_tmp14_ = picker_click_gesture;
#line 60 "../src/Widgets/FocusPicker.vala"
	_tmp15_ = _g_object_ref0 ((GtkEventController*) _tmp14_);
#line 60 "../src/Widgets/FocusPicker.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp13_, _tmp15_);
#line 62 "../src/Widgets/FocusPicker.vala"
	_tmp16_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 62 "../src/Widgets/FocusPicker.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp16_, (guint) GDK_BUTTON_PRIMARY);
#line 62 "../src/Widgets/FocusPicker.vala"
	gtk_event_controller_set_propagation_phase ((GtkEventController*) _tmp16_, GTK_PHASE_CAPTURE);
#line 62 "../src/Widgets/FocusPicker.vala"
	fixed_click_gesture = _tmp16_;
#line 66 "../src/Widgets/FocusPicker.vala"
	_tmp17_ = fixed_click_gesture;
#line 66 "../src/Widgets/FocusPicker.vala"
	g_signal_connect_object (_tmp17_, "pressed", (GCallback) _tuba_widgets_focus_picker_on_fixed_click_gtk_gesture_click_pressed, self, 0);
#line 67 "../src/Widgets/FocusPicker.vala"
	_tmp18_ = self->priv->fixed;
#line 67 "../src/Widgets/FocusPicker.vala"
	_tmp19_ = fixed_click_gesture;
#line 67 "../src/Widgets/FocusPicker.vala"
	_tmp20_ = _g_object_ref0 ((GtkEventController*) _tmp19_);
#line 67 "../src/Widgets/FocusPicker.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp18_, _tmp20_);
#line 69 "../src/Widgets/FocusPicker.vala"
	_tmp21_ = (GtkEventControllerMotion*) gtk_event_controller_motion_new ();
#line 69 "../src/Widgets/FocusPicker.vala"
	motion = _tmp21_;
#line 70 "../src/Widgets/FocusPicker.vala"
	_tmp22_ = motion;
#line 70 "../src/Widgets/FocusPicker.vala"
	g_signal_connect_object (_tmp22_, "motion", (GCallback) _tuba_widgets_focus_picker_on_motion_gtk_event_controller_motion_motion, self, 0);
#line 71 "../src/Widgets/FocusPicker.vala"
	_tmp23_ = self->priv->fixed;
#line 71 "../src/Widgets/FocusPicker.vala"
	_tmp24_ = motion;
#line 71 "../src/Widgets/FocusPicker.vala"
	_tmp25_ = _g_object_ref0 ((GtkEventController*) _tmp24_);
#line 71 "../src/Widgets/FocusPicker.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp23_, _tmp25_);
#line 37 "../src/Widgets/FocusPicker.vala"
	_g_object_unref0 (motion);
#line 37 "../src/Widgets/FocusPicker.vala"
	_g_object_unref0 (fixed_click_gesture);
#line 37 "../src/Widgets/FocusPicker.vala"
	_g_object_unref0 (picker_click_gesture);
#line 37 "../src/Widgets/FocusPicker.vala"
	return obj;
#line 824 "FocusPicker.c"
}

static void
tuba_widgets_focus_picker_class_init (TubaWidgetsFocusPickerClass * klass,
                                      gpointer klass_data)
{
#line 7 "../src/Widgets/FocusPicker.vala"
	tuba_widgets_focus_picker_parent_class = g_type_class_peek_parent (klass);
#line 7 "../src/Widgets/FocusPicker.vala"
	g_type_class_adjust_private_offset (klass, &TubaWidgetsFocusPicker_private_offset);
#line 7 "../src/Widgets/FocusPicker.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) tuba_widgets_focus_picker_real_size_allocate;
#line 7 "../src/Widgets/FocusPicker.vala"
	((GtkWidgetClass *) klass)->measure = (void (*) (GtkWidget*, GtkOrientation, gint, gint*, gint*, gint*, gint*)) tuba_widgets_focus_picker_real_measure;
#line 7 "../src/Widgets/FocusPicker.vala"
	((GtkWidgetClass *) klass)->snapshot = (void (*) (GtkWidget*, GtkSnapshot*)) tuba_widgets_focus_picker_real_snapshot;
#line 7 "../src/Widgets/FocusPicker.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tuba_widgets_focus_picker_get_property;
#line 7 "../src/Widgets/FocusPicker.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tuba_widgets_focus_picker_set_property;
#line 7 "../src/Widgets/FocusPicker.vala"
	G_OBJECT_CLASS (klass)->constructor = tuba_widgets_focus_picker_constructor;
#line 7 "../src/Widgets/FocusPicker.vala"
	G_OBJECT_CLASS (klass)->finalize = tuba_widgets_focus_picker_finalize;
#line 7 "../src/Widgets/FocusPicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_FOCUS_PICKER_POS_X_PROPERTY, tuba_widgets_focus_picker_properties[TUBA_WIDGETS_FOCUS_PICKER_POS_X_PROPERTY] = g_param_spec_double ("pos-x", "pos-x", "pos-x", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 7 "../src/Widgets/FocusPicker.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TUBA_WIDGETS_FOCUS_PICKER_POS_Y_PROPERTY, tuba_widgets_focus_picker_properties[TUBA_WIDGETS_FOCUS_PICKER_POS_Y_PROPERTY] = g_param_spec_double ("pos-y", "pos-y", "pos-y", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 853 "FocusPicker.c"
}

static void
tuba_widgets_focus_picker_instance_init (TubaWidgetsFocusPicker * self,
                                         gpointer klass)
{
#line 7 "../src/Widgets/FocusPicker.vala"
	self->priv = tuba_widgets_focus_picker_get_instance_private (self);
#line 14 "../src/Widgets/FocusPicker.vala"
	self->priv->_pos_x = 0.0;
#line 24 "../src/Widgets/FocusPicker.vala"
	self->priv->_pos_y = 0.0;
#line 34 "../src/Widgets/FocusPicker.vala"
	self->priv->picker_width_half = (gdouble) 0;
#line 35 "../src/Widgets/FocusPicker.vala"
	self->priv->picker_height_half = (gdouble) 0;
#line 82 "../src/Widgets/FocusPicker.vala"
	self->priv->dragging = FALSE;
#line 872 "FocusPicker.c"
}

static void
tuba_widgets_focus_picker_finalize (GObject * obj)
{
	TubaWidgetsFocusPicker * self;
	GtkAspectFrame* _tmp0_;
#line 7 "../src/Widgets/FocusPicker.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TUBA_WIDGETS_TYPE_FOCUS_PICKER, TubaWidgetsFocusPicker);
#line 188 "../src/Widgets/FocusPicker.vala"
	g_debug ("FocusPicker.vala:188: Destroying FocusPicker");
#line 189 "../src/Widgets/FocusPicker.vala"
	_tmp0_ = self->priv->frame;
#line 189 "../src/Widgets/FocusPicker.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 8 "../src/Widgets/FocusPicker.vala"
	_g_object_unref0 (self->priv->pic);
#line 9 "../src/Widgets/FocusPicker.vala"
	_g_object_unref0 (self->priv->fixed);
#line 10 "../src/Widgets/FocusPicker.vala"
	_g_object_unref0 (self->priv->picker);
#line 11 "../src/Widgets/FocusPicker.vala"
	_g_object_unref0 (self->priv->frame);
#line 12 "../src/Widgets/FocusPicker.vala"
	_g_object_unref0 (self->priv->overlay);
#line 7 "../src/Widgets/FocusPicker.vala"
	G_OBJECT_CLASS (tuba_widgets_focus_picker_parent_class)->finalize (obj);
#line 900 "FocusPicker.c"
}

 G_GNUC_NO_INLINE static GType
tuba_widgets_focus_picker_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TubaWidgetsFocusPickerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tuba_widgets_focus_picker_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TubaWidgetsFocusPicker), 0, (GInstanceInitFunc) tuba_widgets_focus_picker_instance_init, NULL };
	GType tuba_widgets_focus_picker_type_id;
	tuba_widgets_focus_picker_type_id = g_type_register_static (gtk_widget_get_type (), "TubaWidgetsFocusPicker", &g_define_type_info, 0);
	TubaWidgetsFocusPicker_private_offset = g_type_add_instance_private (tuba_widgets_focus_picker_type_id, sizeof (TubaWidgetsFocusPickerPrivate));
	return tuba_widgets_focus_picker_type_id;
}

GType
tuba_widgets_focus_picker_get_type (void)
{
	static gsize tuba_widgets_focus_picker_type_id__once = 0;
	if (g_once_init_enter (&tuba_widgets_focus_picker_type_id__once)) {
		GType tuba_widgets_focus_picker_type_id;
		tuba_widgets_focus_picker_type_id = tuba_widgets_focus_picker_get_type_once ();
		g_once_init_leave (&tuba_widgets_focus_picker_type_id__once, tuba_widgets_focus_picker_type_id);
	}
	return tuba_widgets_focus_picker_type_id__once;
}

static void
_vala_tuba_widgets_focus_picker_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	TubaWidgetsFocusPicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUBA_WIDGETS_TYPE_FOCUS_PICKER, TubaWidgetsFocusPicker);
#line 7 "../src/Widgets/FocusPicker.vala"
	switch (property_id) {
#line 7 "../src/Widgets/FocusPicker.vala"
		case TUBA_WIDGETS_FOCUS_PICKER_POS_X_PROPERTY:
#line 7 "../src/Widgets/FocusPicker.vala"
		g_value_set_double (value, tuba_widgets_focus_picker_get_pos_x (self));
#line 7 "../src/Widgets/FocusPicker.vala"
		break;
#line 7 "../src/Widgets/FocusPicker.vala"
		case TUBA_WIDGETS_FOCUS_PICKER_POS_Y_PROPERTY:
#line 7 "../src/Widgets/FocusPicker.vala"
		g_value_set_double (value, tuba_widgets_focus_picker_get_pos_y (self));
#line 7 "../src/Widgets/FocusPicker.vala"
		break;
#line 947 "FocusPicker.c"
		default:
#line 7 "../src/Widgets/FocusPicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/Widgets/FocusPicker.vala"
		break;
#line 953 "FocusPicker.c"
	}
}

static void
_vala_tuba_widgets_focus_picker_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	TubaWidgetsFocusPicker * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TUBA_WIDGETS_TYPE_FOCUS_PICKER, TubaWidgetsFocusPicker);
#line 7 "../src/Widgets/FocusPicker.vala"
	switch (property_id) {
#line 7 "../src/Widgets/FocusPicker.vala"
		case TUBA_WIDGETS_FOCUS_PICKER_POS_X_PROPERTY:
#line 7 "../src/Widgets/FocusPicker.vala"
		tuba_widgets_focus_picker_set_pos_x (self, g_value_get_double (value));
#line 7 "../src/Widgets/FocusPicker.vala"
		break;
#line 7 "../src/Widgets/FocusPicker.vala"
		case TUBA_WIDGETS_FOCUS_PICKER_POS_Y_PROPERTY:
#line 7 "../src/Widgets/FocusPicker.vala"
		tuba_widgets_focus_picker_set_pos_y (self, g_value_get_double (value));
#line 7 "../src/Widgets/FocusPicker.vala"
		break;
#line 979 "FocusPicker.c"
		default:
#line 7 "../src/Widgets/FocusPicker.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../src/Widgets/FocusPicker.vala"
		break;
#line 985 "FocusPicker.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

